#define ALLOW_ACCESS_TO_INTERNALS_OF_MENUS

#include <Standalone.h>
#include "../Include/endianutils.h"
#include "../Include/palmos5.h"

#define vchrJogUp				(0x1700)
#define vchrJogDown				(0x1701)

#define RESID 1000

STANDALONE_CODE_RESOURCE_TYPESTR_ID("armc", RESID);

typedef void (*pfnEvtGetEvent)(EventType *event, Int32 timeout);

typedef struct
{
	UInt32	chr:16;
	UInt32	RepeatCount:16;
} NFmjGlobalsType;

void MyEvtGetEvent (EventType *event, Int32 timeout)
{
	NFmjGlobalsType global;
	UInt32* dmy = (UInt32*)&global;

	pfnEvtGetEvent oldTrap;

	//--Check Repeating
	if (!FtrGet (MY_CRID, 1001, (UInt32 *)&global))
	{
		if (global.RepeatCount != 0)
		{
			event->eType = keyDownEvent;
			event->data.keyDown.chr = global.chr;
			event->data.keyDown.keyCode = 0;
			event->data.keyDown.modifiers = commandKeyMask;
			global.RepeatCount = global.RepeatCount - 1;
			FtrSet (MY_CRID, 1001, *dmy);
			return;
		}
	}

	FtrGet(MY_CRID, RESID, (UInt32 *)&oldTrap);
	oldTrap(event, timeout);

	//--Check event to Handle
	if (event->eType != keyDownEvent)
		return;

	//--Check chr-code to Handle
	switch (event->data.keyDown.chr)
		{
		case vchrJogUp:
		case vchrJogDown:
			break;
		default:
			return;
		}

	//--Check Active Form is ID #1000
	if (FrmGetActiveFormID () != 1000)
		return;
			
	//--Check Current App is NetFront
	LocalID lid;
	UInt16 cardNo;
	UInt32 crid;
	if (SysCurAppDatabaseV40(&cardNo, &lid) == errNone){
		if (DmDatabaseInfoV40(cardNo, lid, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &crid)
			== errNone){
			if (crid != 'NF3T')
				return;
			}
		}

	//--Check Menu is active
	MenuBarType *menuP = MenuGetActiveMenu();
	if (menuP != NULL && menuP->attr.visible)
		return;

	//--Check MenuCommandBar is open
	if (MenuCmdBarGetButtonData (0, NULL, NULL, NULL, NULL))
		return;

	//--Set Repeat
	global.chr = event->data.keyDown.chr;
	global.RepeatCount = 8;
	FtrSet (MY_CRID, 1001, *dmy);
}

