#define ALLOW_ACCESS_TO_INTERNALS_OF_MENUS

#include <Standalone.h>
#include "../Include/endianutils.h"
#include "../Include/palmos5.h"

#define vchrJogUp				(0x1700)
#define vchrJogDown				(0x1701)

#define RESID 1000

STANDALONE_CODE_RESOURCE_TYPESTR_ID("armc", RESID);

typedef void (*pfnEvtGetEvent)(EventType *event, Int32 timeout);

void MyEvtGetEvent (EventType *event, Int32 timeout){
	pfnEvtGetEvent oldTrap;

	FtrGet(MY_CRID, RESID, (UInt32 *)&oldTrap);
	oldTrap(event, timeout);

	//--Check event to Handle
	if (event->eType != keyDownEvent)
		return;

	//--Check chr-code to Handle
	switch (event->data.keyDown.chr)
		{
		case vchrJogUp:
		case vchrJogDown:
			break;
		default:
			return;
		}

	//--Check Active Form is ID #1000
	if (FrmGetActiveFormID () != 1000)
		return;
			
	//--Check Current App is NetFront
	LocalID lid;
	UInt16 cardNo;
	UInt32 crid;
	if (SysCurAppDatabaseV40(&cardNo, &lid) == errNone){
		if (DmDatabaseInfoV40(cardNo, lid, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &crid)
			== errNone){
			if (crid != 'NF3T')
				return;
			}
		}

	//--Check Menu is active
	MenuBarType *menuP = MenuGetActiveMenu();
	if (menuP != NULL && menuP->attr.visible)
		return;

	//--Check MenuCommandBar is open
	if (MenuCmdBarGetButtonData (0, NULL, NULL, NULL, NULL))
		return;

	//--Replace chr-code
	event->data.keyDown.chr -= (vchrJogUp - vchrPageUp);
}
