#define ALLOW_ACCESS_TO_INTERNALS_OF_MENUS

#include <Standalone.h>
#include "../Include/endianutils.h"
#include "../Include/palmos5.h"
#include "PalmChars.h"

#define stdTimeSelectorForm							10200
#define stdTimeSelectorStartTimePushButton			10204
#define stdTimeSelectorEndTimePushButton			10205
#define stdTimeSelectorHourList						10206
#define stdTimeSelectorMinuteList					10207
#define stdTimeSelectorMinuteDummyList				10219
#define stdTimeSelectorStartTimeMinIncRepeating		10220
#define stdTimeSelectorStartTimeMinDecRepeating		10221
#define stdTimeSelectorEndTimeMinIncRepeating		10223
#define stdTimeSelectorEndTimeMinDecRepeating		10224

#define calTimeSelectorForm							7200
#define calTimeSelectorStartTimePushButton			7204
#define calTimeSelectorEndTimePushButton			7205
#define calTimeSelectorHourList						7206
#define calTimeSelectorMinuteList					7207
#define calTimeSelectorMinuteDummyList				7219
#define calTimeSelectorStartTimeMinIncRepeating		7221
#define calTimeSelectorStartTimeMinDecRepeating		7222
#define calTimeSelectorEndTimeMinIncRepeating		7223
#define calTimeSelectorEndTimeMinDecRepeating		7224

#define vchrJogUp				0x1700
#define vchrJogDown				0x1701
#define vchrJogPushedUp			0x1703
#define vchrJogPushedDown		0x1704
#define vchrJogRelease			0x1706
#define vchrJogBack				0x1707
#define vchrJogLeft				0x1708
#define vchrJogRight			0x1709

#define RESID 1001

STANDALONE_CODE_RESOURCE_TYPESTR_ID("armc", RESID);

typedef void (*pfnEvtGetEvent)(EventType *event, Int32 timeout);

UInt16 minuteToSelection (UInt16 minute);

//-----------------
void MyEvtGetEvent (EventType *event, Int32 timeout){
	pfnEvtGetEvent oldTrap;

	UInt16	TimeSelectorForm;
	UInt16	TimeSelectorStartTimePushButton;
	UInt16	TimeSelectorEndTimePushButton;
	UInt16	TimeSelectorHourList;
	UInt16	TimeSelectorMinuteList;
	UInt16	TimeSelectorMinuteDummyList;
	UInt16	TimeSelectorStartTimeMinIncRepeating;
	UInt16	TimeSelectorStartTimeMinDecRepeating;
	UInt16	TimeSelectorEndTimeMinIncRepeating;
	UInt16	TimeSelectorEndTimeMinDecRepeating;

	FtrGet(MY_CRID, RESID, (UInt32 *)&oldTrap);
	oldTrap(event, timeout);

	EventType newEvent;
	MemSet (&newEvent, sizeof(SysEventType), 0);

	LocalID lid;
	UInt16 cardNo;
	UInt32 crid;

//	// check Event to Handle and FormID (TimeSelectorForm)
	switch (event->eType)
	{
	case nilEvent:
	case keyDownEvent:
	case winEnterEvent:
	case ctlSelectEvent:
	case ctlRepeatEvent:
	case lstEnterEvent:
	case lstSelectEvent:
//		UInt16 frmID = FrmGetActiveFormID ();
		if ((FrmGetActiveFormID () != stdTimeSelectorForm)
			&& (FrmGetActiveFormID () != calTimeSelectorForm))
			return;
		break;
	case frmOpenEvent:
		//--Check Current App is Calendar-PDat
		if (SysCurAppDatabaseV40(&cardNo, &lid) == errNone){
			if (DmDatabaseInfoV40(cardNo, lid, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &crid)
				== errNone){
				if (crid != 'PDat')
					return;
				}
			}
		DmOpenDatabaseByTypeCreator ('HACK', 'SeT3', dmModeReadOnly);
			return;
		break;
default:
		return;
	}

	if (FrmGetActiveFormID () == stdTimeSelectorForm)
	{
		TimeSelectorForm = stdTimeSelectorForm;
		TimeSelectorStartTimePushButton = stdTimeSelectorStartTimePushButton;
		TimeSelectorEndTimePushButton = stdTimeSelectorEndTimePushButton;
		TimeSelectorHourList = stdTimeSelectorHourList;
		TimeSelectorMinuteList = stdTimeSelectorMinuteList;
		TimeSelectorMinuteDummyList = stdTimeSelectorMinuteDummyList;
		TimeSelectorStartTimeMinIncRepeating = stdTimeSelectorStartTimeMinIncRepeating;
		TimeSelectorStartTimeMinDecRepeating = stdTimeSelectorStartTimeMinDecRepeating;
		TimeSelectorEndTimeMinIncRepeating = stdTimeSelectorEndTimeMinIncRepeating;
		TimeSelectorEndTimeMinDecRepeating = stdTimeSelectorEndTimeMinDecRepeating;
	}
	else if (FrmGetActiveFormID () == calTimeSelectorForm)
	{
		TimeSelectorForm = calTimeSelectorForm;
		TimeSelectorStartTimePushButton = calTimeSelectorStartTimePushButton;
		TimeSelectorEndTimePushButton = calTimeSelectorEndTimePushButton;
		TimeSelectorHourList = calTimeSelectorHourList;
		TimeSelectorMinuteList = calTimeSelectorMinuteList;
		TimeSelectorMinuteDummyList = calTimeSelectorMinuteDummyList;
		TimeSelectorStartTimeMinIncRepeating = calTimeSelectorStartTimeMinIncRepeating;
		TimeSelectorStartTimeMinDecRepeating = calTimeSelectorStartTimeMinDecRepeating;
		TimeSelectorEndTimeMinIncRepeating = calTimeSelectorEndTimeMinIncRepeating;
		TimeSelectorEndTimeMinDecRepeating = calTimeSelectorEndTimeMinDecRepeating;
	}

//	// get object pointer and Control status
//		// Form object pointer
	FormType *formP = FrmGetActiveForm ();
	if (FrmGetObjectIndex (formP, TimeSelectorHourList) == frmInvalidObjectId)
		return;
//		// List object pointer
	ListPtr hoursLst = (ListPtr)FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, TimeSelectorHourList));
	ListPtr minutesLst = (ListPtr)FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, TimeSelectorMinuteList));
	ListPtr minutesDmyLst = (ListPtr)FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, TimeSelectorMinuteDummyList));
//		// Control object pointer
	ControlPtr startTimeCtl = (ControlType*)FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, TimeSelectorStartTimePushButton));
	ControlPtr endTimeCtl = (ControlType*)FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, TimeSelectorEndTimePushButton));
//		// Control object status
	Int16 startTimeCtlValue = CtlGetValue (startTimeCtl);
	Int16 endTimeCtlValue = CtlGetValue (endTimeCtl);

//	// Event Handle
//		// winEnterEvent to initialize Dummy List selection
//		// nilEvent to update Dummy List selection
	if ((event->eType == winEnterEvent) || (event->eType == nilEvent))
	{
		LstSetSelection (minutesDmyLst, (UInt8)(LstGetSelection (minutesLst) * 5) / 5);
	}
//		// lstEnterEvent Accept or Not
	if (event->eType == lstEnterEvent)
	{
		if (event->data.lstEnter.listID == TimeSelectorMinuteDummyList)
		{
			if (LstGetSelection (minutesLst) == noListSelection)
			{
				SndPlaySystemSound (sndError);
				event->eType = nilEvent;
				return;
			}
		}
	}
//		// lstSelectEvent to Update actual minutesLst
	if (event->eType == lstSelectEvent)
	{
		if (event->data.lstSelect.listID == TimeSelectorMinuteDummyList)
		{
			LstSetSelection (minutesLst, LstGetSelection (minutesDmyLst));
			newEvent.eType = lstSelectEvent;
			newEvent.data.lstSelect.listID = TimeSelectorMinuteList;
			SysEventAddToQueue (&newEvent);
			return;
		}
	}
//		// ctlSelectEvent to check StartTime or EndTimePushButton
//		// if true need update minutesDmyList
	if (event->eType == ctlSelectEvent)
	{
		switch (event->data.ctlSelect.controlID)
		{
		case calTimeSelectorStartTimePushButton:
		case calTimeSelectorEndTimePushButton:
		case stdTimeSelectorStartTimePushButton:
		case stdTimeSelectorEndTimePushButton:
			newEvent.eType = nilEvent;
			SysEventAddToQueue (&newEvent);
			return;
		}
	}
//	// check tab Char or 5-Way Left,Right
	if (event->eType == keyDownEvent)
	{
		newEvent.eType = (eventsEnum)(event->eType);
		newEvent.data.keyDown.chr = (event->data.keyDown.chr);
		newEvent.data.keyDown.keyCode = (event->data.keyDown.keyCode);
		newEvent.data.keyDown.modifiers = (event->data.keyDown.modifiers);
		if ((event->data.keyDown.chr == tabChr) ||
			(event->data.keyDown.chr == chrLeftArrow) ||
			(event->data.keyDown.chr == chrRightArrow) ||
			(event->data.keyDown.chr == vchrJogLeft) ||
			(event->data.keyDown.chr == vchrJogRight) ||
			NavKeyPressed(&newEvent, Right) || NavKeyPressed(&newEvent, Left))
			{
				if (startTimeCtlValue)
				{
					CtlHitControl (endTimeCtl);
					CtlHitControl (endTimeCtl);
					event->eType = nilEvent;
					return;
				}
				else
				{
					CtlHitControl (startTimeCtl);
					CtlHitControl (startTimeCtl);
					event->eType = nilEvent;
					return;
				}
			}
		if (LstGetSelection (minutesLst) == noListSelection)
		{
			if ((event->data.keyDown.chr == tabChr) ||
				(event->data.keyDown.chr == chrUpArrow) ||
				(event->data.keyDown.chr == chrDownArrow) ||
				(event->data.keyDown.chr == chrPageUp) ||
				(event->data.keyDown.chr == chrPageDown))
			{
				CtlHitControl (startTimeCtl);
				CtlHitControl (startTimeCtl);
			}
		}
	}
//	// check current selection in minutesList
	if (LstGetSelection (minutesLst) == noListSelection)
			return;
//		// keyDownEvent ctlSelectEvent ctlRepeatEvent
	if ((event->eType == keyDownEvent) ||
		(event->eType == ctlSelectEvent) ||
		(event->eType == ctlRepeatEvent))
	{
//		// check which Control is Active End or Not
		Char *CtlLabelP;
		if (endTimeCtlValue)
			CtlLabelP = (char*)CtlGetLabel (endTimeCtl);
		else
			CtlLabelP = (char*)CtlGetLabel (startTimeCtl);
//		// check ControlID to Handle or Not
		if ((event->eType == ctlSelectEvent) || (event->eType == ctlRepeatEvent))
		{
			switch (event->data.ctlSelect.controlID)
			{
			case calTimeSelectorStartTimePushButton:
			case calTimeSelectorEndTimePushButton:
			case stdTimeSelectorStartTimePushButton:
			case stdTimeSelectorEndTimePushButton:
				break;
			case calTimeSelectorStartTimeMinIncRepeating:
			case calTimeSelectorStartTimeMinDecRepeating:
			case stdTimeSelectorStartTimeMinIncRepeating:
			case stdTimeSelectorStartTimeMinDecRepeating:
				if (((!startTimeCtlValue) && (!endTimeCtlValue)) || (endTimeCtlValue))
				{
					ControlPtr startTimeMinIncCtl = (ControlType*)FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, TimeSelectorStartTimeMinIncRepeating));
					ControlPtr startTimeMinDecCtl = (ControlType*)FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, TimeSelectorStartTimeMinDecRepeating));
					CtlSetValue (startTimeMinIncCtl, true);
					CtlSetValue (startTimeMinDecCtl, true);
					CtlSetValue (startTimeMinIncCtl, false);
					CtlSetValue (startTimeMinDecCtl, false);
					CtlHitControl (startTimeCtl);
					CtlHitControl (startTimeCtl);
					event->eType = nilEvent;
					return;
				}
				break;
			case calTimeSelectorEndTimeMinIncRepeating:
			case calTimeSelectorEndTimeMinDecRepeating:
			case stdTimeSelectorEndTimeMinIncRepeating:
			case stdTimeSelectorEndTimeMinDecRepeating:
				if (((!startTimeCtlValue) && (!endTimeCtlValue)) || (startTimeCtlValue))
				{
					ControlPtr endTimeMinIncCtl = (ControlType*)FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, TimeSelectorEndTimeMinIncRepeating));
					ControlPtr endTimeMinDecCtl = (ControlType*)FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, TimeSelectorEndTimeMinDecRepeating));
					CtlSetValue (endTimeMinIncCtl, true);
					CtlSetValue (endTimeMinDecCtl, true);
					CtlSetValue (endTimeMinIncCtl, false);
					CtlSetValue (endTimeMinDecCtl, false);
					CtlHitControl (endTimeCtl);
					CtlHitControl (endTimeCtl);
					event->eType = nilEvent;
					return;
				}
				break;
			default:
				return;
			}
		}

//		// get minutes value
		Char *minutesP = StrChr (CtlLabelP, ':') + 1;
		if (minutesP == (Char*)1)
			minutesP = StrChr (CtlLabelP, '.') + 1;
		if (minutesP == (Char*)1)
			minutesP = StrChr (CtlLabelP, ',') + 1;

		Int32 min = StrAToI (minutesP);
		Int32 hour = LstGetSelection (hoursLst);

//		// check Key or ControlID to Handle or Not
		if (event->eType == keyDownEvent)
		{
			switch (event->data.keyDown.chr)
			{
			case tabChr:
				if ((!startTimeCtlValue) && (!endTimeCtlValue))
					EvtEnqueueKey (nextFieldChr, 0, 0);
				event->data.keyDown.chr = nextFieldChr;
				return;
			case backspaceChr:
				LstSetSelection (hoursLst, noListSelection);
				LstSetSelection (minutesLst, noListSelection);
				LstSetSelection (minutesDmyLst, noListSelection);
				return;
			case chrUpArrow:
			case chrPageUp:
				goto Inc;
			case chrDownArrow:
			case chrPageDown:
				goto Dec;
			case vchrJogRelease:
				event->data.keyDown.chr = linefeedChr;
				return;
			}
		}

		if (event->eType == ctlRepeatEvent)
		{
			switch (event->data.ctlRepeat.controlID)
			{
			case calTimeSelectorStartTimeMinIncRepeating:
			case stdTimeSelectorStartTimeMinIncRepeating:
				if (!startTimeCtlValue)
					return;
				goto Inc;
			case calTimeSelectorEndTimeMinIncRepeating:
			case stdTimeSelectorEndTimeMinIncRepeating:
				if (!endTimeCtlValue)
					return;
				goto Inc;
			case calTimeSelectorStartTimeMinDecRepeating:
			case stdTimeSelectorStartTimeMinDecRepeating:
				if (!startTimeCtlValue)
					return;
				goto Dec;
			case calTimeSelectorEndTimeMinDecRepeating:
			case stdTimeSelectorEndTimeMinDecRepeating:
				if (!endTimeCtlValue)
					return;
				goto Dec;
			default:
				return;
			}
		}
		return;

		UInt16 sel;

		Boolean needHoursUpdate = false;

Inc:
		if (min == 59)
		{
			if (hour != 23)
			{
				needHoursUpdate = true;
				LstSetSelection (hoursLst, hour + 1);
				min = -1;
			}
			else
			{
				return;
			}
		}

		min++;

		sel = minuteToSelection (min);

		LstSetSelection (minutesLst, sel);
		LstSetSelection (minutesDmyLst, min / 5);

		if (needHoursUpdate)
		{
			newEvent.eType = lstSelectEvent;
			newEvent.data.lstSelect.listID = TimeSelectorHourList;
			SysEventAddToQueue (&newEvent);
		}

		newEvent.eType = lstSelectEvent;
		newEvent.data.lstSelect.listID = TimeSelectorMinuteList;
		SysEventAddToQueue (&newEvent);

		return;

Dec:
		if (min == 0)
		{
			if (hour != 0)
			{
				needHoursUpdate = true;
				LstSetSelection (hoursLst, hour - 1);
				min = 60;
			}
			else
			{
				return;
			}
		}

		min--;

		sel = minuteToSelection (min);

		LstSetSelection (minutesLst, sel);
		LstSetSelection (minutesDmyLst, min / 5);

		newEvent.eType = lstSelectEvent;
		newEvent.data.lstSelect.listID = TimeSelectorMinuteList;
		SysEventAddToQueue (&newEvent);

		if (needHoursUpdate)
		{
			newEvent.eType = lstSelectEvent;
			newEvent.data.lstSelect.listID = TimeSelectorHourList;
			SysEventAddToQueue (&newEvent);
		}

	}

	return;
}

UInt16 minuteToSelection (UInt16 minute)
{
	UInt16 A = (minute + 4) / 5;
	UInt16 B = (A * 5) - minute;
	UInt16 ret = (51 * B) + A;
	return ret;
}

